//! Autogenerated weights for relay
//!
//! THIS FILE WAS AUTO-GENERATED USING THE SUBSTRATE BENCHMARK CLI VERSION 4.0.0-dev
//! DATE: 2021-09-07, STEPS: `100`, REPEAT: 10, LOW RANGE: `[]`, HIGH RANGE: `[]`
//! EXECUTION: Some(Wasm), WASM-EXECUTION: Compiled, CHAIN: Some("dev"), DB CACHE: 128

// Executed Command:
// target/release/interbtc-standalone
// benchmark
// --chain
// dev
// --execution=wasm
// --wasm-execution=compiled
// --pallet
// relay
// --extrinsic
// *
// --steps
// 100
// --repeat
// 10
// --output
// crates/relay/src/default_weights.rs
// --template
// .deploy/weight-template.hbs


#![cfg_attr(rustfmt, rustfmt_skip)]
#![allow(unused_parens)]
#![allow(unused_imports)]

use frame_support::{traits::Get, weights::{Weight, constants::RocksDbWeight}};
use sp_std::marker::PhantomData;

/// Weight functions needed for relay.
pub trait WeightInfo {
	fn initialize() -> Weight;
	fn store_block_header() -> Weight;
	fn report_vault_theft() -> Weight;
}

/// Weights for relay using the Substrate node and recommended hardware.
pub struct SubstrateWeight<T>(PhantomData<T>);
impl<T: frame_system::Config> WeightInfo for SubstrateWeight<T> {
	// Storage: Security ParachainStatus (r:1 w:0)
	// Storage: BTCRelay BestBlock (r:1 w:1)
	// Storage: BTCRelay ChainCounter (r:1 w:1)
	// Storage: BTCRelay Chains (r:1 w:1)
	// Storage: Security ActiveBlockCount (r:1 w:0)
	// Storage: BTCRelay ChainsHashes (r:0 w:1)
	// Storage: BTCRelay StartBlockHeight (r:0 w:1)
	// Storage: BTCRelay BestBlockHeight (r:0 w:1)
	// Storage: BTCRelay ChainsIndex (r:0 w:1)
	// Storage: BTCRelay BlockHeaders (r:0 w:1)
	fn initialize() -> Weight {
		(52_878_000 as Weight)
			.saturating_add(T::DbWeight::get().reads(5 as Weight))
			.saturating_add(T::DbWeight::get().writes(8 as Weight))
	}
	// Storage: Security ParachainStatus (r:1 w:0)
	// Storage: BTCRelay BlockHeaders (r:2 w:1)
	// Storage: BTCRelay ChainsIndex (r:1 w:1)
	// Storage: BTCRelay DisableDifficultyCheck (r:1 w:0)
	// Storage: BTCRelay ChainsHashes (r:1 w:1)
	// Storage: Security ActiveBlockCount (r:1 w:0)
	// Storage: BTCRelay BestBlock (r:0 w:1)
	// Storage: BTCRelay BestBlockHeight (r:0 w:1)
	fn store_block_header() -> Weight {
		(68_306_000 as Weight)
			.saturating_add(T::DbWeight::get().reads(7 as Weight))
			.saturating_add(T::DbWeight::get().writes(5 as Weight))
	}
	// Storage: Security ParachainStatus (r:1 w:0)
	// Storage: Relay TheftReports (r:1 w:1)
	// Storage: BTCRelay DisableInclusionCheck (r:1 w:0)
	// Storage: BTCRelay BestBlockHeight (r:1 w:0)
	// Storage: BTCRelay Chains (r:1 w:0)
	// Storage: BTCRelay BlockHeaders (r:1 w:0)
	// Storage: BTCRelay StableBitcoinConfirmations (r:1 w:0)
	// Storage: Security ActiveBlockCount (r:1 w:0)
	// Storage: BTCRelay StableParachainConfirmations (r:1 w:0)
	// Storage: VaultRegistry Vaults (r:1 w:1)
	// Storage: Staking Nonce (r:1 w:0)
	// Storage: Staking TotalCurrentStake (r:1 w:1)
	// Storage: Staking Stake (r:1 w:1)
	// Storage: Staking SlashPerToken (r:1 w:0)
	// Storage: Staking SlashTally (r:1 w:1)
	// Storage: Fee TheftFee (r:1 w:0)
	// Storage: Fee TheftFeeMax (r:1 w:0)
	// Storage: Oracle Aggregate (r:1 w:0)
	// Storage: Tokens Accounts (r:2 w:2)
	// Storage: VaultRegistry TotalUserVaultCollateral (r:1 w:1)
	// Storage: Staking TotalStake (r:1 w:1)
	// Storage: Staking RewardTally (r:1 w:1)
	// Storage: Staking RewardPerToken (r:1 w:0)
	// Storage: System Account (r:2 w:1)
	// Storage: VaultRegistry SecureCollateralThreshold (r:1 w:0)
	// Storage: VaultRegistry LiquidationVaultAccountId (r:1 w:0)
	// Storage: VaultRegistry LiquidationVault (r:1 w:1)
	// Storage: Rewards Stake (r:1 w:1)
	// Storage: Rewards TotalStake (r:1 w:1)
	// Storage: Rewards RewardTally (r:1 w:1)
	// Storage: Rewards RewardPerToken (r:1 w:0)
	fn report_vault_theft() -> Weight {
		(478_713_000 as Weight)
			.saturating_add(T::DbWeight::get().reads(33 as Weight))
			.saturating_add(T::DbWeight::get().writes(15 as Weight))
	}
}

// For backwards compatibility and tests
impl WeightInfo for () {
	// Storage: Security ParachainStatus (r:1 w:0)
	// Storage: BTCRelay BestBlock (r:1 w:1)
	// Storage: BTCRelay ChainCounter (r:1 w:1)
	// Storage: BTCRelay Chains (r:1 w:1)
	// Storage: Security ActiveBlockCount (r:1 w:0)
	// Storage: BTCRelay ChainsHashes (r:0 w:1)
	// Storage: BTCRelay StartBlockHeight (r:0 w:1)
	// Storage: BTCRelay BestBlockHeight (r:0 w:1)
	// Storage: BTCRelay ChainsIndex (r:0 w:1)
	// Storage: BTCRelay BlockHeaders (r:0 w:1)
	fn initialize() -> Weight {
		(52_878_000 as Weight)
			.saturating_add(RocksDbWeight::get().reads(5 as Weight))
			.saturating_add(RocksDbWeight::get().writes(8 as Weight))
	}
	// Storage: Security ParachainStatus (r:1 w:0)
	// Storage: BTCRelay BlockHeaders (r:2 w:1)
	// Storage: BTCRelay ChainsIndex (r:1 w:1)
	// Storage: BTCRelay DisableDifficultyCheck (r:1 w:0)
	// Storage: BTCRelay ChainsHashes (r:1 w:1)
	// Storage: Security ActiveBlockCount (r:1 w:0)
	// Storage: BTCRelay BestBlock (r:0 w:1)
	// Storage: BTCRelay BestBlockHeight (r:0 w:1)
	fn store_block_header() -> Weight {
		(68_306_000 as Weight)
			.saturating_add(RocksDbWeight::get().reads(7 as Weight))
			.saturating_add(RocksDbWeight::get().writes(5 as Weight))
	}
	// Storage: Security ParachainStatus (r:1 w:0)
	// Storage: Relay TheftReports (r:1 w:1)
	// Storage: BTCRelay DisableInclusionCheck (r:1 w:0)
	// Storage: BTCRelay BestBlockHeight (r:1 w:0)
	// Storage: BTCRelay Chains (r:1 w:0)
	// Storage: BTCRelay BlockHeaders (r:1 w:0)
	// Storage: BTCRelay StableBitcoinConfirmations (r:1 w:0)
	// Storage: Security ActiveBlockCount (r:1 w:0)
	// Storage: BTCRelay StableParachainConfirmations (r:1 w:0)
	// Storage: VaultRegistry Vaults (r:1 w:1)
	// Storage: Staking Nonce (r:1 w:0)
	// Storage: Staking TotalCurrentStake (r:1 w:1)
	// Storage: Staking Stake (r:1 w:1)
	// Storage: Staking SlashPerToken (r:1 w:0)
	// Storage: Staking SlashTally (r:1 w:1)
	// Storage: Fee TheftFee (r:1 w:0)
	// Storage: Fee TheftFeeMax (r:1 w:0)
	// Storage: Oracle Aggregate (r:1 w:0)
	// Storage: Tokens Accounts (r:2 w:2)
	// Storage: VaultRegistry TotalUserVaultCollateral (r:1 w:1)
	// Storage: Staking TotalStake (r:1 w:1)
	// Storage: Staking RewardTally (r:1 w:1)
	// Storage: Staking RewardPerToken (r:1 w:0)
	// Storage: System Account (r:2 w:1)
	// Storage: VaultRegistry SecureCollateralThreshold (r:1 w:0)
	// Storage: VaultRegistry LiquidationVaultAccountId (r:1 w:0)
	// Storage: VaultRegistry LiquidationVault (r:1 w:1)
	// Storage: Rewards Stake (r:1 w:1)
	// Storage: Rewards TotalStake (r:1 w:1)
	// Storage: Rewards RewardTally (r:1 w:1)
	// Storage: Rewards RewardPerToken (r:1 w:0)
	fn report_vault_theft() -> Weight {
		(478_713_000 as Weight)
			.saturating_add(RocksDbWeight::get().reads(33 as Weight))
			.saturating_add(RocksDbWeight::get().writes(15 as Weight))
	}
}

